/*
*******************************************************************************
**
**  This device driver was created by Applilet for the 78K0S/KB1+, 78K0S/KA1+,
**  78K0S/KY1+ 8-Bit Single-Chip Microcontrollers.
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	main.c
**  Abstract :	This file implements main function.
**  APIlib :	NEC78K0SKX1+.lib V1.50 [23 Feb. 2006]
**
**  Device :	uPD78F9222
**
**  Compiler :	NEC/CC78K0
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "ad.h"
#include "int.h"
#include "port.h"
#include "timer.h"
#include "lvi.h"
/*
*******************************************************************************
**  MacroDefine
*******************************************************************************
*/
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	This function implements main function.
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
unsigned char	mode;
unsigned char	s[16];

void	time_wait(unsigned int time)
{
	while(time!=0){
	time--;
	}
}

void	input_mode(void)
{
	mode=0;
	if(P2.0==0){mode=mode+1;}
	if(P2.1==0){mode=mode+2;}
	if(P2.2==0){mode=mode+4;}
	if(P2.3==0){mode=mode+8;}
}

void	left_motor_set(unsigned char data)
{
	switch(data){
		case 0:P3.0=0;P3.1=0;break;
		case 1:P3.0=1;P3.1=0;break;
		case 2:P3.0=0;P3.1=1;break;
	}

}

void	right_motor_set(unsigned char data)
{
	switch(data){
		case 0:P4.4=0;P4.5=0;break;
		case 1:P4.4=1;P4.5=0;break;
		case 2:P4.4=0;P4.5=1;break;
	}

}

void	left_speed_set(unsigned char data)
{
	switch(data){
		case 0:P4.0=0;P4.1=0;P4.2=0;P4.3=0;break;
		case 1:P4.0=1;P4.1=0;P4.2=0;P4.3=0;break;
		case 2:P4.0=0;P4.1=1;P4.2=0;P4.3=0;break;
		case 3:P4.0=1;P4.1=1;P4.2=0;P4.3=0;break;
		case 4:P4.0=0;P4.1=0;P4.2=1;P4.3=0;break;
		case 5:P4.0=1;P4.1=0;P4.2=1;P4.3=0;break;
		case 6:P4.0=0;P4.1=1;P4.2=1;P4.3=0;break;
		case 7:P4.0=1;P4.1=1;P4.2=1;P4.3=0;break;
		case 8:P4.0=0;P4.1=0;P4.2=0;P4.3=1;break;
		case 9:P4.0=1;P4.1=0;P4.2=0;P4.3=1;break;
		case 10:P4.0=0;P4.1=1;P4.2=0;P4.3=1;break;
		case 11:P4.0=1;P4.1=1;P4.2=0;P4.3=1;break;
		case 12:P4.0=0;P4.1=0;P4.2=1;P4.3=1;break;
		case 13:P4.0=1;P4.1=0;P4.2=1;P4.3=1;break;
		case 14:P4.0=0;P4.1=1;P4.2=1;P4.3=1;break;
		case 15:P4.0=1;P4.1=1;P4.2=1;P4.3=1;break;
	}

}

void	right_speed_set(unsigned char data)
{
	switch(data){
		case 0:P12.1=0;P12.2=0;P12.3=0;P13.0=0;break;
		case 1:P12.1=1;P12.2=0;P12.3=0;P13.0=0;break;
		case 2:P12.1=0;P12.2=1;P12.3=0;P13.0=0;break;
		case 3:P12.1=1;P12.2=1;P12.3=0;P13.0=0;break;
		case 4:P12.1=0;P12.2=0;P12.3=1;P13.0=0;break;
		case 5:P12.1=1;P12.2=0;P12.3=1;P13.0=0;break;
		case 6:P12.1=0;P12.2=1;P12.3=1;P13.0=0;break;
		case 7:P12.1=1;P12.2=1;P12.3=1;P13.0=0;break;
		case 8:P12.1=0;P12.2=0;P12.3=0;P13.0=1;break;
		case 9:P12.1=1;P12.2=0;P12.3=0;P13.0=1;break;
		case 10:P12.1=0;P12.2=1;P12.3=0;P13.0=1;break;
		case 11:P12.1=1;P12.2=1;P12.3=0;P13.0=1;break;
		case 12:P12.1=0;P12.2=0;P12.3=1;P13.0=1;break;
		case 13:P12.1=1;P12.2=0;P12.3=1;P13.0=1;break;
		case 14:P12.1=0;P12.2=1;P12.3=1;P13.0=1;break;
		case 15:P12.1=1;P12.2=1;P12.3=1;P13.0=1;break;
	}

}
void	set_step(unsigned char no)
{
	switch(no){
		case 0:s[0]=0x77;s[1]=0xff;s[2]=0xff;s[3]=0x7b;s[4]=0x77;s[5]=0xff;s[6]=0xff;s[7]=0x7b;
				s[8]=0x77;s[9]=0xff;s[10]=0xff;s[11]=0x7b;s[12]=0x77;s[13]=0xff;s[14]=0xff;s[15]=0x7b;break;
		case 1:s[0]=0x77;s[1]=0xff;s[2]=0xff;s[3]=0xb0;s[4]=0xbb;s[5]=0xff;s[6]=0xff;s[7]=0x07;
				s[8]=0x77;s[9]=0xff;s[10]=0xff;s[11]=0x0b;s[12]=0xbb;s[13]=0xff;s[14]=0xff;s[15]=0x70;break;
		case 2:s[0]=0x77;s[1]=0x00;s[2]=0x77;s[3]=0x00;s[4]=0x77;s[5]=0x00;s[6]=0x77;s[7]=0x00;
				s[8]=0xbb;s[9]=0x00;s[10]=0xbb;s[11]=0x00;s[12]=0xbb;s[13]=0x00;s[14]=0xbb;s[15]=0x70;break;
		case 3:s[0]=0x70;s[1]=0x07;s[2]=0x70;s[3]=0x07;s[4]=0x70;s[5]=0x07;s[6]=0x70;s[7]=0xb0;
				s[8]=0x07;s[9]=0x70;s[10]=0x07;s[11]=0x70;s[12]=0x07;s[13]=0x70;s[14]=0x07;s[15]=0x0b;break;
		case 4:s[0]=0x7b;s[1]=0x7b;s[2]=0x7b;s[3]=0x77;s[4]=0xb7;s[5]=0xb7;s[6]=0xb7;s[7]=0x77;
				s[8]=0x7b;s[9]=0x7b;s[10]=0x7b;s[11]=0xbb;s[12]=0xb7;s[13]=0xb7;s[14]=0xb7;s[15]=0xbb;break;
		case 5:s[0]=0x77;s[1]=0x7b;s[2]=0x77;s[3]=0x7b;s[4]=0x77;s[5]=0x7b;s[6]=0x77;s[7]=0x7b;
				s[8]=0x77;s[9]=0x7b;s[10]=0x77;s[11]=0x7b;s[12]=0x77;s[13]=0x7b;s[14]=0x77;s[15]=0x7b;break;
		case 6:s[0]=0x77;s[1]=0x77;s[2]=0x77;s[3]=0x77;s[4]=0x77;s[5]=0x77;s[6]=0x77;s[7]=0x7b;
				s[8]=0x77;s[9]=0x77;s[10]=0x77;s[11]=0x77;s[12]=0x77;s[13]=0x77;s[14]=0x77;s[15]=0x7b;break;
		case 7:s[0]=0x77;s[1]=0x70;s[2]=0x77;s[3]=0x70;s[4]=0x77;s[5]=0x70;s[6]=0x77;s[7]=0x70;
				s[8]=0x77;s[9]=0x70;s[10]=0x77;s[11]=0x70;s[12]=0x77;s[13]=0x70;s[14]=0x77;s[15]=0x70;break;
		case 8:s[0]=0x7b;s[1]=0xb7;s[2]=0x7b;s[3]=0xb7;s[4]=0x7b;s[5]=0xb7;s[6]=0x7b;s[7]=0xbb;
				s[8]=0xb7;s[9]=0x7b;s[10]=0xb7;s[11]=0x7b;s[12]=0xb7;s[13]=0x7b;s[14]=0xb7;s[15]=0x77;break;
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:break;
	}
}
void	sub_shori_left(unsigned char data)
{
	switch(data){
		case 15:break;
		case 14:break;
		case 13:break;
		case 12:break;
		case 11:left_motor_set(2);left_speed_set(15);break;
		case 10:left_motor_set(2);left_speed_set(12);break;
		case 9:left_motor_set(2);left_speed_set(9);break;
		case 8:left_motor_set(2);left_speed_set(6);break;
		case 7:left_motor_set(1);left_speed_set(15);break;
		case 6:left_motor_set(1);left_speed_set(12);break;
		case 5:left_motor_set(1);left_speed_set(9);break;
		case 4:left_motor_set(1);left_speed_set(6);break;
		case 3:left_motor_set(0);left_speed_set(0);break;
		case 2:left_motor_set(0);left_speed_set(0);break;
		case 1:left_motor_set(0);left_speed_set(0);break;
		case 0:left_motor_set(0);left_speed_set(0);break;
	}

}
void	sub_shori_right(unsigned char data)
{
	switch(data){
		case 15:break;
		case 14:break;
		case 13:break;
		case 12:break;
		case 11:right_motor_set(2);right_speed_set(15);break;
		case 10:right_motor_set(2);right_speed_set(14);break;
		case 9:right_motor_set(2);right_speed_set(13);break;
		case 8:right_motor_set(2);right_speed_set(12);break;
		case 7:right_motor_set(1);right_speed_set(15);break;
		case 6:right_motor_set(1);right_speed_set(14);break;
		case 5:right_motor_set(1);right_speed_set(13);break;
		case 4:right_motor_set(1);right_speed_set(12);break;
		case 3:right_motor_set(0);right_speed_set(0);break;
		case 2:right_motor_set(0);right_speed_set(0);break;
		case 1:right_motor_set(0);right_speed_set(0);break;
		case 0:right_motor_set(0);right_speed_set(0);break;
	}

}

void	step_shori(unsigned char no)
{
unsigned char	left_data;
unsigned char	right_data;
unsigned char	data;

	data=s[no];
	left_data=(data&0xf0)>>4;
	right_data=data&0x0f;
	sub_shori_left(left_data);
	sub_shori_right(right_data);

}
void	time_wait_sub(void)
{
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);
		time_wait(20000);

}
void main( void )
{
	/* TODO. add user code */

	input_mode();
	set_step(mode);

	while(1){
		step_shori(0);
		time_wait_sub();
		step_shori(1);
		time_wait_sub();
		step_shori(2);
		time_wait_sub();
		step_shori(3);
		time_wait_sub();
		step_shori(4);
		time_wait_sub();
		step_shori(5);
		time_wait_sub();
		step_shori(6);
		time_wait_sub();
		step_shori(7);
		time_wait_sub();
		step_shori(8);
		time_wait_sub();
		step_shori(9);
		time_wait_sub();
		step_shori(10);
		time_wait_sub();
		step_shori(11);
		time_wait_sub();
		step_shori(12);
		time_wait_sub();
		step_shori(13);
		time_wait_sub();
		step_shori(14);
		time_wait_sub();
		step_shori(15);
		time_wait_sub();

	}
}

